]> git.ipfire.org Git - thirdparty/git.git/blame - git-repack.sh
Git 1.7.8-rc2
[thirdparty/git.git] / git-repack.sh
CommitLineData
b2d46199 1#!/bin/sh
ccf1ee32
JH
2#
3# Copyright (c) 2005 Linus Torvalds
4#
5
5715d0bb
PH
6OPTIONS_KEEPDASHDASH=
7OPTIONS_SPEC="\
1b1dd23f 8git repack [options]
5715d0bb
PH
9--
10a pack everything in a single pack
ca11b212 11A same as -a, and turn unreachable objects loose
5715d0bb 12d remove redundant packs, and run git-prune-packed
5c47e1c7
JK
13f pass --no-reuse-delta to git-pack-objects
14F pass --no-reuse-object to git-pack-objects
2b36b146 15n do not run git-update-server-info
5715d0bb
PH
16q,quiet be quiet
17l pass --local to git-pack-objects
18 Packing constraints
19window= size of the window used for delta compression
20window-memory= same as the above, but limit memory size instead of entries count
21depth= limits the maximum delta depth
22max-pack-size= maximum size of each packfile
23"
d0b353b1 24SUBDIRECTORY_OK='Yes'
ae2b0f15 25. git-sh-setup
ccb36504 26
ca11b212 27no_update_info= all_into_one= remove_redundant= unpack_unreachable=
2e6a30ef 28local= no_reuse= extra=
822f7c73 29while test $# != 0
ccf1ee32
JH
30do
31 case "$1" in
32 -n) no_update_info=t ;;
d5acdcf1 33 -a) all_into_one=t ;;
65aa5302 34 -A) all_into_one=t
ca11b212 35 unpack_unreachable=--unpack-unreachable ;;
0adb3358 36 -d) remove_redundant=t ;;
2e6a30ef 37 -q) GIT_QUIET=t ;;
5c47e1c7
JK
38 -f) no_reuse=--no-reuse-delta ;;
39 -F) no_reuse=--no-reuse-object ;;
cec2be76 40 -l) local=--local ;;
5715d0bb
PH
41 --max-pack-size|--window|--window-memory|--depth)
42 extra="$extra $1=$2"; shift ;;
43 --) shift; break;;
9678faaa 44 *) usage ;;
ccf1ee32
JH
45 esac
46 shift
47done
48
22c79eab 49case "`git config --bool repack.usedeltabaseoffset || echo true`" in
b6945f57
JH
50true)
51 extra="$extra --delta-base-offset" ;;
52esac
53
d5acdcf1 54PACKDIR="$GIT_OBJECT_DIRECTORY/pack"
e32dfec7 55PACKTMP="$PACKDIR/.tmp-$$-pack"
0ea2582d
ML
56rm -f "$PACKTMP"-*
57trap 'rm -f "$PACKTMP"-*' 0 1 2 3 15
d5acdcf1
JH
58
59# There will be more repacking strategies to come...
60case ",$all_into_one," in
61,,)
cd0d74d2 62 args='--unpacked --incremental'
d5acdcf1
JH
63 ;;
64,t,)
2478dc84 65 args= existing=
ce859074
SP
66 if [ -d "$PACKDIR" ]; then
67 for e in `cd "$PACKDIR" && find . -type f -name '*.pack' \
68 | sed -e 's/^\.\///' -e 's/\.pack$//'`
69 do
70 if [ -e "$PACKDIR/$e.keep" ]; then
71 : keep
72 else
ce859074
SP
73 existing="$existing $e"
74 fi
75 done
171110a4 76 if test -n "$existing" -a -n "$unpack_unreachable" -a \
83d0289d 77 -n "$remove_redundant"
f7991d1e
BC
78 then
79 args="$args $unpack_unreachable"
80 fi
65aa5302 81 fi
d5acdcf1
JH
82 ;;
83esac
0ea2582d 84
e32dfec7
TR
85mkdir -p "$PACKDIR" || exit
86
2e6a30ef 87args="$args $local ${GIT_QUIET:+-q} $no_reuse$extra"
7f3140cd 88names=$(git pack-objects --keep-true-parents --honor-pack-keep --non-empty --all --reflog $args </dev/null "$PACKTMP") ||
b2d46199 89 exit 1
6b94b1a0 90if [ -z "$names" ]; then
2e6a30ef 91 say Nothing new to pack.
6b94b1a0 92fi
d5acdcf1 93
3e6b1d0a 94# Ok we have prepared all new packfiles.
3e6b1d0a
JH
95
96# First see if there are packs of the same name and if so
97# if we can move them out of the way (this can happen if we
98# repacked immediately after packing fully.
99rollback=
100failed=
101for name in $names
102do
2ad47d61
JH
103 for sfx in pack idx
104 do
3e6b1d0a
JH
105 file=pack-$name.$sfx
106 test -f "$PACKDIR/$file" || continue
107 rm -f "$PACKDIR/old-$file" &&
108 mv "$PACKDIR/$file" "$PACKDIR/old-$file" || {
109 failed=t
110 break
111 }
112 rollback="$rollback $file"
113 done
114 test -z "$failed" || break
115done
116
117# If renaming failed for any of them, roll the ones we have
118# already renamed back to their original names.
119if test -n "$failed"
120then
121 rollback_failure=
122 for file in $rollback
123 do
124 mv "$PACKDIR/old-$file" "$PACKDIR/$file" ||
125 rollback_failure="$rollback_failure $file"
126 done
127 if test -n "$rollback_failure"
128 then
129 echo >&2 "WARNING: Some packs in use have been renamed by"
130 echo >&2 "WARNING: prefixing old- to their name, in order to"
131 echo >&2 "WARNING: replace them with the new version of the"
132 echo >&2 "WARNING: file. But the operation failed, and"
133 echo >&2 "WARNING: attempt to rename them back to their"
134 echo >&2 "WARNING: original names also failed."
135 echo >&2 "WARNING: Please rename them in $PACKDIR manually:"
136 for file in $rollback_failure
137 do
138 echo >&2 "WARNING: old-$file -> $file"
139 done
140 fi
141 exit 1
142fi
143
144# Now the ones with the same name are out of the way...
145fullbases=
146for name in $names
147do
148 fullbases="$fullbases pack-$name"
149 chmod a-w "$PACKTMP-$name.pack"
150 chmod a-w "$PACKTMP-$name.idx"
0ea2582d 151 mv -f "$PACKTMP-$name.pack" "$PACKDIR/pack-$name.pack" &&
3e6b1d0a
JH
152 mv -f "$PACKTMP-$name.idx" "$PACKDIR/pack-$name.idx" ||
153 exit
154done
155
156# Remove the "old-" files
157for name in $names
158do
159 rm -f "$PACKDIR/old-pack-$name.idx"
160 rm -f "$PACKDIR/old-pack-$name.pack"
6b94b1a0 161done
d5acdcf1 162
3e6b1d0a
JH
163# End of pack replacement.
164
0adb3358 165if test "$remove_redundant" = t
d5acdcf1 166then
ce859074
SP
167 # We know $existing are all redundant.
168 if [ -n "$existing" ]
62af0b53 169 then
6ed64058
JH
170 ( cd "$PACKDIR" &&
171 for e in $existing
172 do
dca3957b
DH
173 case " $fullbases " in
174 *" $e "*) ;;
ce859074 175 *) rm -f "$e.pack" "$e.idx" "$e.keep" ;;
62af0b53 176 esac
6ed64058
JH
177 done
178 )
d5acdcf1 179 fi
2e6a30ef 180 git prune-packed ${GIT_QUIET:+-q}
d5acdcf1 181fi
ccf1ee32 182
ccf1ee32
JH
183case "$no_update_info" in
184t) : ;;
e1dc49bc 185*) git update-server-info ;;
ccf1ee32 186esac